package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:爱丁堡利手量表
 * @date 2021/7/20 15:55
 */
public class EHSScale extends BaseScale{

    public EHSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*ScaleUtil.getScaleDll("EHSSCALE.dll");
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.EHSScale(jsonArray.toString(), resultJson.toString());
        //System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //总得分
        double score = 0;
        //左手得分
        double score1 = 0;
        //右手得分
        double score2 = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("checkItems").equals("左")) {
                score1 += 2;
            } else if (jsonObject1.getString("checkItems").equals("右")) {
                score2 += 2;
            } else if (jsonObject1.getString("checkItems").equals("左右均可")) {
                score1 += 1;
                score2 += 1;
            }
        }
        DecimalFormat df   = new DecimalFormat("######0.00");
        score = Double.parseDouble(df.format((score2-score1)/(score2+score1)*100));
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));
        if (score < -40){
            resultMap.put("结论", "左利手");
            resultJson.put("结论", "左利手");
        }else if (score > 40){
            resultMap.put("结论", "右利手");
            resultJson.put("结论", "右利手");
        }else {
            resultMap.put("结论", "双利手");
            resultJson.put("结论", "双利手");
        }

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_EHS);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
